package cn.estsh.i3plus.pojo.base.enumutil;

import com.fasterxml.jackson.annotation.JsonFormat;

/**
 * @Description :
 * @Reference :
 * @Author : silliter
 * @CreateDate : 2019-05-13 15:53
 * @Modify:
 **/
public class AndonEnumUtil {
    /**
     * 按灯状态
     * 10-是，20-否
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum IS_ALARM_STATUS{

        YES(10,"需要按灯"),
        ON(20,"不需要按灯");

        private int value;
        private String description;

        IS_ALARM_STATUS(int value, String description) {
            this.value = value;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }

        public static String valueOfDescription(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }

    /**
     * 按灯业务状态
     * 安灯状态=10，工号 =20 ，读取状态=30
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum ALARM_BUSI_FLAG{

        ALARM_FLAG("10","按灯状态"),
        USER_CODE("20","工号"),
        READ_FLAG("30", "读取状态");

        private String value;
        private String description;

        ALARM_BUSI_FLAG(String value, String description) {
            this.value = value;
            this.description = description;
        }

        public String getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }
    }

    /**
     * 按灯标识
     * 1-呼叫，2-签到，3-解决
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum ALARM_FLAG{

        CALL(1,"10","呼叫"),
        SIGN(2,"20","签到"),
        RESOLVE(3,"30","解决"),
        CANCEL(4,"40", "撤销");

        private int value;
        private String code;
        private String description;

        ALARM_FLAG(int value,String code, String description) {
            this.value = value;
            this.code = code;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getCode(){ return code; }

        public String getDescription() {
            return description;
        }

        public static String valueOfDescription(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }

    /**
     * 按灯动作标志
     * 呼叫=10，签到 =20 ，撤销=30，40-解决，50-转呼
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum ANDON_ACTION_FLAG{

        CALL_ACTION("10","呼叫动作"),
        SIGN_ACTION("20","签到动作"),
        CANCEL_ACTION("30", "撤销动作"),
        RESOLVE_ACTION("40", "解决动作"),
        SHIFG_CALL_ACTION("50", "转呼动作");

        private String value;
        private String description;

        ANDON_ACTION_FLAG(String value, String description) {
            this.value = value;
            this.description = description;
        }

        public String getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }
    }

    /**
     * 优先级别
     * 1 - 一级，2 - 二级，3 - 三级，4 - 四级
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum ALARM_PRIORITY{

        FIRST(1,"一级"),
        SECOND(2,"二级"),
        THIRD(3,"三级"),
        FOURTH(4,"四级");

        private int value;
        private String description;

        ALARM_PRIORITY(int value, String description) {
            this.value = value;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }

        public static String valueOfDescription(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }
}
